package it.coderunner.spring.data.service;

/**
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.io.Serializable;
import java.util.List;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import it.coderunner.spring.data.model.City;

public interface CityService extends Serializable{

	City findByNameAndVoivodeshipAllIgnoringCase(String name, String voivodeship);

	City save(City city);
	
	List<City> findFirst10ByVoivodeship(String voivodeship);
	
	Page<City> findAll(Pageable pageable);

	City findOne(Long id);

	void delete(Long id);

}
