package it.coderunner.spring.data.service;

/**
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
   
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
   
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.util.List;

import javax.annotation.Resource;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import it.coderunner.spring.data.dao.CityRepository;
import it.coderunner.spring.data.model.City;

@Service
public class CityServiceImpl implements CityService{

	private static final long serialVersionUID = -5212497294563141450L;
	
	@Resource
	private CityRepository cityRepository;

	@Override
	public City findByNameAndVoivodeshipAllIgnoringCase(String name, String voivodeship) {
		return cityRepository.findByNameAndVoivodeshipAllIgnoringCase(name, voivodeship) ;
	}

	@Override
	public City save(City city) {
		return cityRepository.save(city);
	}

	@Override
	public List<City> findFirst10ByVoivodeship(String voivodeship) {
		return cityRepository.findFirst10ByVoivodeship(voivodeship);
	}

	@Override
	public Page<City> findAll(Pageable pageable) {
		return cityRepository.findAll(pageable);
	}

	@Override
	public City findOne(Long id) {
		return cityRepository.findOne(id);
	}

	@Override
	public void delete(Long id) {
		cityRepository.delete(id);
	}

}
