String.prototype.isBlank = function() {
    return (this.length === 0 || !this.trim());
}

cityListCoreAction = function(buttonElement) {
	$button = $(buttonElement);
	page = parseInt($button.attr('page')) || 0;
	
	if (!$button.hasClass('disabled'))
    jQuery.ajax({
    	'url': '/get/all/' + page
		,'type' : 'GET'
		,'dataType': 'json'			
	    ,'success' : function(data) {		
	    	var $collection = $('#city-list-group');
	    	var $previous = $('.glyphicon-triangle-left');
	    	var $forward = $('.glyphicon-triangle-right');
	    	
	    	var cities = data.content;
	    	
	    	$('.bs-dynamic-item').remove();
	    	for (var i = 0; i < cities.length; i++) { 
	            $collection.append('<li class="list-group-item bs-dynamic-item">'+cities[i].name+'</li>');	   

	            $li = $collection.children(':last');
	            $li.attr("arrayIndex" , $li.index()+1);
	            $li.attr("tableIndex" , cities[i].id);
	            
	            CITYTREASUREBOOK[$li.index()+1] = {
	            	 'name-addon' : cities[i].name
	            	,'voivodeship-addon' : cities[i].voivodeship
	            	,'birthdate-addon' : cities[i].birthdate
	            	,'note-addon' : cities[i].note	    	            	 
	            }	            
	    	}

	    	if (data.last) { $forward.addClass('disabled'); $previous.removeClass('disabled') };
	    	if (data.first) { $previous.addClass('disabled'); $forward.removeClass('disabled') };
	    	
	    	if (page >= 0 && !$previous.hasClass('disabled')) page -= 1
	    	if (page < data.totalPage && !$forward.hasClass('disabled')) page += 1
	    }
    });   
}	

jQuery( document ).ready(function() {

	CITYTREASUREBOOK = {
		'1': {
          	 'name-addon' : 'Wrocław'
         	,'voivodeship-addon' : 'dolnośląskie'
         	,'birthdate-addon' : 'X wiek'
         	,'note-addon' : ''			
		}
	};

    jQuery('.btn-primary').click(function(event) {
        var pname = $('#city-name').val() || "";
        var pvoivodeship = $('#city-voivodeship').val() || "";
        var text = 'Puste pola nie są akceptowalne.';
        
        if (pname.isBlank() || pvoivodeship.isBlank()) {
        		$('#alert-modal').find('p').text(text);
				$('#alert-modal').modal();
				return false;
        } else {
        		var $collection = $('#city-list-group');
                jQuery.ajax({
                	'url': '/save/city/'+pname+'/'+pvoivodeship
            		,'type' : 'GET'
        			,'dataType': 'json'	
            	    ,'success' : function(data) {	
            	    	if (data.success) {
            	    		$collection.append('<li class="list-group-item">'+pname+'</li>');
            	    		$li = $collection.children(':last');
            	    		$li.attr("arrayIndex" , $li.index()+1);
            	    		$li.attr("tableIndex" , data.tableIndex);
            	    		
            	    		CITYTREASUREBOOK[$li.index()+1] = {
            	    				'name-addon' : pname
            	    				,'voivodeship-addon' : pvoivodeship
            	    				,'birthdate-addon' : ''
            	    				,'note-addon' : ''
            	    		};
            	    		$li.click();
            	    		if ($li.index()+1 > 10) jQuery('.glyphicon-triangle-right').removeClass('disabled');
            	    	}
            	    	$('#alert-modal').find('p').text(data.message);
            	    	$('#alert-modal').modal();
            	    }
                });
        }
    });
    
    jQuery('.glyphicon-remove').on('click',function(event) {
        var $li = $('.list-group').children('.active:first');
        var tableIndex = parseInt($li.attr("tableIndex"));  
    
        if ( $li.index() > 0 ) {
            jQuery.ajax({
            	'url': '/delete/city/'+tableIndex
        		,'type' : 'GET'
    			,'dataType': 'json'	
        	    ,'success' : function(data) {	        
        	    	if (data.success) {
        	    		$li.remove();
        	    	} 
        	    	$('#alert-modal').find('p').text(data.message);
        	    	$('#alert-modal').modal();
        	    }
            });
        } else {
          text = $li.index() === 0 ? 'Nie można usunąć tejże pozycji.' : 'Należy najpierw wybrać pozycję, przed dokonaniem tej operacji.'
          $('#alert-modal').find('p').text(text)
          $('#alert-modal').modal();
        }
    });
    
    jQuery('.glyphicon-triangle-left ,.glyphicon-triangle-right').on('click',function(event) {
    	cityListCoreAction(event.target);
    });

    jQuery.ajax({
    	'url': '/get/all/0'
		,'type' : 'GET'
		,'dataType': 'json'				
	    ,'success' : function(data) {		
	    	var $collection = $('#city-list-group');
	    	var cities = data.content;
	    	for (var i = 0; i < cities.length; i++) { 
	            $collection.append('<li class="list-group-item bs-dynamic-item">'+cities[i].name+'</li>');

	            $li = $collection.children(':last');
	            $li.attr("arrayIndex" , $li.index()+1);
	            $li.attr("tableIndex" , cities[i].id);
	            
	            CITYTREASUREBOOK[$li.index()+1] = {
	            	 'name-addon' : cities[i].name
	            	,'voivodeship-addon' : cities[i].voivodeship
	            	,'birthdate-addon' : cities[i].birthdate
	            	,'note-addon' : cities[i].note	            	 
	            }
	    	}
	        
	        jQuery('#city-list-group').on('click' ,'.list-group-item' ,function(event){
	          var $previous = $(event.target).closest('.list-group').children('.active:first');
	          var $current = $(event.target);
	          var $form = $("#update-city-form");
	          
	          var tableIndex = parseInt($previous.attr("tableIndex")); 
	          var x;

	          if (tableIndex) {
	        	  $('#id-addon').val(tableIndex);
	        	  $.post( $form.attr('action'), $form.serialize(), function(data) {
	        		  // ... do something with response from server
	        	  }
	        	  ,'json'
	        	  );	          
	          }
   		   
	          $previous.removeClass('active'); 
	          $current.addClass('active'); 
	          
	          var i = $previous.attr("arrayIndex");
	          for(x in CITYTREASUREBOOK[i])
	    	      CITYTREASUREBOOK[i][x] = $('#'+x).val();      
	    	      
	    	   var i = $current.attr("arrayIndex");   
	    	   for(x in CITYTREASUREBOOK[i]) {
	    	   	 $('#'+x).val(CITYTREASUREBOOK[i][x]);
	    	   }
	    	   
	        });
	    	
	    	if (data.totalPages > 1) jQuery('.glyphicon-triangle-right').removeClass('disabled');
	    }
    });
        
});